Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/NikonCustom.pm	(revision 34921)
@@ -16,5 +16,9 @@
 use vars qw($VERSION);
 
-$VERSION = '1.06';
+$VERSION = '1.17';
+
+my %offOn = ( 0 => 'Off', 1 => 'On' );
+my %onOff = ( 0 => 'On', 1 => 'Off' );
+my %noYes = ( 0 => 'No', 1 => 'Yes' );
 
 # custom settings for the D80 (encrypted) - ref JD
@@ -30,16 +34,10 @@
         Name => 'Beep',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'On',
-            0x80 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     0.2 => { # CS4
         Name => 'AFAssist',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'On',
-            0x40 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     0.3 => { # CS5
@@ -47,6 +45,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Release Locked',
-            0x20 => 'Enable Release',
+            0 => 'Release Locked',
+            1 => 'Enable Release',
         },
     },
@@ -54,24 +52,15 @@
         Name => 'ImageReview',
         Mask => 0x10,
-        PrintConv => {
-            0x00 => 'On',
-            0x10 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     0.5 => { # CS17
         Name => 'Illumination',
         Mask => 0x08,
-        PrintConv => {
-            0x00 => 'Off',
-            0x08 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     0.6 => { # CS11
         Name => 'MainDialExposureComp',
         Mask => 0x04,
-        PrintConv => {
-            0x00 => 'Off',
-            0x04 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     0.7 => { # CS10
@@ -79,6 +68,6 @@
         Mask => 0x01,
         PrintConv => {
-            0x00 => '1/3 EV',
-            0x01 => '1/2 EV',
+            0 => '1/3 EV',
+            1 => '1/2 EV',
         },
     },
@@ -86,8 +75,5 @@
         Name => 'AutoISO',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     1.2 => { # CS7-a
@@ -95,8 +81,8 @@
         Mask => 0x30,
         PrintConv => {
-            0x00 => 200,
-            0x10 => 400,
-            0x20 => 800,
-            0x30 => 1600,
+            0 => 200,
+            1 => 400,
+            2 => 800,
+            3 => 1600,
         },
     },
@@ -106,15 +92,15 @@
         PrintConvColumns => 2,
         PrintConv => {
-            0x00 => '1/125 s',
-            0x01 => '1/100 s',
-            0x02 => '1/80 s',
-            0x03 => '1/60 s',
-            0x04 => '1/40 s',
-            0x05 => '1/30 s',
-            0x06 => '1/15 s',
-            0x07 => '1/8 s',
-            0x08 => '1/4 s',
-            0x09 => '1/2 s',
-            0x0a => '1 s',
+            0 => '1/125 s',
+            1 => '1/100 s',
+            2 => '1/80 s',
+            3 => '1/60 s',
+            4 => '1/40 s',
+            5 => '1/30 s',
+            6 => '1/15 s',
+            7 => '1/8 s',
+            8 => '1/4 s',
+            9 => '1/2 s',
+            10 => '1 s',
         },
     },
@@ -123,8 +109,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'AE & Flash',
-            0x40 => 'AE Only',
-            0x80 => 'Flash Only',
-            0xc0 => 'WB Bracketing',
+            0 => 'AE & Flash',
+            1 => 'AE Only',
+            2 => 'Flash Only',
+            3 => 'WB Bracketing',
         },
     },
@@ -133,6 +119,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => '0,-,+',
-            0x20 => '-,0,+',
+            0 => '0,-,+',
+            1 => '-,0,+',
         },
     },
@@ -141,10 +127,10 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '5 s',
-            0x20 => '10 s',
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '5 min',
-            0xa0 => '10 min',
+            0 => '5 s',
+            1 => '10 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '5 min',
+            5 => '10 min',
         },
     },
@@ -153,10 +139,10 @@
         Mask => 0x1c,
         PrintConv => {
-            0x00 => '4 s',
-            0x04 => '6 s',
-            0x08 => '8 s',
-            0x0c => '16 s',
-            0x10 => '30 s',
-            0x14 => '30 min',
+            0 => '4 s',
+            1 => '6 s',
+            2 => '8 s',
+            3 => '16 s',
+            4 => '30 s',
+            5 => '30 min',
         },
     },
@@ -165,8 +151,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => '2 s',
-            0x01 => '5 s',
-            0x02 => '10 s',
-            0x03 => '20 s',
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
         },
     },
@@ -175,15 +161,15 @@
         Mask => 0x1e,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x02 => 'AE Lock Only',
-            0x04 => 'AF Lock Only',
-            0x06 => 'AE Lock (hold)',
-            0x08 => 'AF-ON',
-            0x0a => 'FV Lock',
-            0x0c => 'Focus Area Selection',
-            0x0e => 'AE-L/AF-L/AF Area',
-            0x10 => 'AE-L/AF Area',
-            0x12 => 'AF-L/AF Area',
-            0x14 => 'AF-ON/AF Area',
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only',
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
+            5 => 'FV Lock',
+            6 => 'Focus Area Selection',
+            7 => 'AE-L/AF-L/AF Area',
+            8 => 'AE-L/AF Area',
+            9 => 'AF-L/AF Area',
+            10 => 'AF-ON/AF Area',
         },
     },
@@ -191,8 +177,5 @@
         Name => 'AELock',
         Mask => 0x01,
-        PrintConv => {
-            0x00 => 'Off',
-            0x01 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     4.3 => { # CS30
@@ -200,8 +183,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => '1 min',
-            0x40 => '5 min',
-            0x80 => '10 min',
-            0xc0 => '15 min',
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
         },
     },
@@ -210,6 +193,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => 'Standard (Main Shutter, Sub Aperture)',
-            0x80 => 'Reversed (Main Aperture, Sub Shutter)',
+            0 => 'Standard (Main Shutter, Sub Aperture)',
+            1 => 'Reversed (Main Aperture, Sub Shutter)',
         },
     },
@@ -218,13 +201,13 @@
         Mask => 0x78,
         PrintConv => {
-            0x00 => 'ISO Display',
-            0x08 => 'Framing Grid',
-            0x10 => 'AF-area Mode',
-            0x18 => 'Center AF Area',
-            0x20 => 'FV Lock',
-            0x28 => 'Flash Off',
-            0x30 => 'Matrix Metering',
-            0x38 => 'Center-weighted',
-            0x40 => 'Spot Metering',
+            0 => 'ISO Display',
+            1 => 'Framing Grid',
+            2 => 'AF-area Mode',
+            3 => 'Center AF Area',
+            4 => 'FV Lock',
+            5 => 'Flash Off',
+            6 => 'Matrix Metering',
+            7 => 'Center-weighted',
+            8 => 'Spot Metering',
         },
     },
@@ -232,16 +215,10 @@
         Name => 'GridDisplay',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'Off',
-            0x80 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     6.2 => { # CS9
         Name => 'ViewfinderWarning',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'On',
-            0x40 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     6.3 => { # CS12
@@ -249,7 +226,7 @@
         Mask => 0x0c,
         PrintConv => {
-            0x00 => '6 mm',
-            0x04 => '8 mm',
-            0x08 => '10 mm',
+            0 => '6 mm',
+            1 => '8 mm',
+            2 => '10 mm',
         },
     },
@@ -257,8 +234,5 @@
         Name => 'ExposureDelayMode',
         Mask => 0x20,
-        PrintConv => {
-            0x00 => 'Off',
-            0x20 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     6.5 => { # CS32
@@ -266,8 +240,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'LR6 (AA Alkaline)',
-            0x01 => 'HR6 (AA Ni-MH)',
-            0x02 => 'FR6 (AA Lithium)',
-            0x03 => 'ZR6 (AA Ni-Mg)',
+            0 => 'LR6 (AA Alkaline)',
+            1 => 'HR6 (AA Ni-MH)',
+            2 => 'FR6 (AA Lithium)',
+            3 => 'ZR6 (AA Ni-Mg)',
         },
     },
@@ -275,14 +249,11 @@
         Name => 'FlashWarning',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'On',
-            0x80 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     7.2 => { # CS24
         Name => 'FlashShutterSpeed',
         Mask => 0x78,
-        ValueConv => '2 ** (($val >> 3) - 6)',
-        ValueConvInv => '$val>0 ? int(log($val)/log(2)+6+0.5) << 3 : 0',
+        ValueConv => '2 ** ($val - 6)',
+        ValueConvInv => '$val>0 ? int(log($val)/log(2)+6+0.5) : 0',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -291,16 +262,10 @@
         Name => 'AutoFP',
         Mask => 0x04,
-        PrintConv => {
-            0x00 => 'Off',
-            0x04 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     7.4 => { # CS26
         Name => 'ModelingFlash',
         Mask => 0x02,
-        PrintConv => {
-            0x00 => 'Off',
-            0x02 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     8.1 => { # CS22
@@ -308,8 +273,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'TTL',
-            0x40 => 'Manual',
-            0x80 => 'Repeating Flash',
-            0xc0 => 'Commander Mode',
+            0 => 'TTL',
+            1 => 'Manual',
+            2 => 'Repeating Flash',
+            3 => 'Commander Mode',
         },
     },
@@ -328,6 +293,6 @@
         Name => 'RepeatingFlashOutput',
         Mask => 0x70,
-        ValueConv => '2 ** (-($val>>4)-2)',
-        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)-2+0.5)<<4 : 0',
+        ValueConv => '2 ** (-$val-2)',
+        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)-2+0.5) : 0',
         PrintConv => 'Image::ExifTool::Exif::PrintExposureTime($val)',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -342,6 +307,6 @@
         Name => 'RepeatingFlashRate',
         Mask => 0xf0,
-        ValueConv => 'my $v=($val>>4); $v < 10 ? $v + 1 : 10 * ($v - 8)',
-        ValueConvInv => 'int(($val <= 10 ? $val - 1 : $val / 10 + 8) + 0.5) << 4',
+        ValueConv => '$val < 10 ? $val + 1 : 10 * ($val - 8)',
+        ValueConvInv => 'int(($val <= 10 ? $val - 1 : $val / 10 + 8) + 0.5)',
         PrintConv => '"$val Hz"',
         PrintConvInv => '$val=~/(\d+)/; $1 || 0',
@@ -357,7 +322,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'TTL',
-            0x40 => 'Manual',
-            0x80 => 'Off',
+            0 => 'TTL',
+            1 => 'Manual',
+            2 => 'Off',
         },
     },
@@ -366,8 +331,8 @@
         Mask => 0x30,
         PrintConv => {
-            0x00 => 'TTL',
-            0x10 => 'Auto Aperture',
-            0x20 => 'Manual',
-            0x30 => 'Off',
+            0 => 'TTL',
+            1 => 'Auto Aperture',
+            2 => 'Manual',
+            3 => 'Off',
         },
     },
@@ -376,8 +341,8 @@
         Mask => 0x0c,
         PrintConv => {
-            0x00 => 'TTL',
-            0x04 => 'Auto Aperture',
-            0x08 => 'Manual',
-            0x0c => 'Off',
+            0 => 'TTL',
+            1 => 'Auto Aperture',
+            2 => 'Manual',
+            3 => 'Off',
         },
     },
@@ -393,6 +358,6 @@
         Name => 'CommanderInternalManualOutput',
         Mask => 0xe0,
-        ValueConv => '2 ** (-($val>>5))',
-        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) << 5 : 0',
+        ValueConv => '2 ** (-$val)',
+        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) : 0',
         PrintConv => q{
             return 'Full' if $val > 0.99;
@@ -412,6 +377,6 @@
         Name => 'CommanderGroupAManualOutput',
         Mask => 0xe0,
-        ValueConv => '2 ** (-($val>>5))',
-        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) << 5 : 0',
+        ValueConv => '2 ** (-$val)',
+        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) : 0',
         PrintConv => q{
             return 'Full' if $val > 0.99;
@@ -431,6 +396,6 @@
         Name => 'CommanderGroupBManualOutput',
         Mask => 0xe0,
-        ValueConv => '2 ** (-($val>>5))',
-        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) << 5 : 0',
+        ValueConv => '2 ** (-$val)',
+        ValueConvInv => '$val > 0 ? int(-log($val)/log(2)+0.5) : 0',
         PrintConv => q{
             return 'Full' if $val > 0.99;
@@ -443,6 +408,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => 'Normal Zone',
-            0x80 => 'Wide Zone',
+            0 => 'Normal Zone',
+            1 => 'Wide Zone',
         },
     },
@@ -451,6 +416,6 @@
         Mask => 0x04,
         PrintConv => {
-            0x00 => 'No Wrap',
-            0x04 => 'Wrap',
+            0 => 'No Wrap',
+            1 => 'Wrap',
         },
     },
@@ -459,7 +424,7 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'Auto',
-            0x01 => 'Off',
-            0x02 => 'On',
+            0 => 'Auto',
+            1 => 'Off',
+            2 => 'On',
         },
     },
@@ -468,7 +433,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Single Area',
-            0x40 => 'Dynamic Area',
-            0x80 => 'Auto-area',
+            0 => 'Single Area',
+            1 => 'Dynamic Area',
+            2 => 'Auto-area',
         },
     },
@@ -487,16 +452,10 @@
         Name => 'Beep',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'On',
-            0x80 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     0.2 => { # CS9
         Name => 'AFAssist',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'On',
-            0x40 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     0.3 => { # CS6
@@ -504,6 +463,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Release Locked',
-            0x20 => 'Enable Release',
+            0 => 'Release Locked',
+            1 => 'Enable Release',
         },
     },
@@ -511,16 +470,10 @@
         Name => 'ImageReview',
         Mask => 0x10,
-        PrintConv => {
-            0x00 => 'On',
-            0x10 => 'Off',
-        },
+        PrintConv => \%onOff,
     },
     1.1 => { # CS10-a
         Name => 'AutoISO',
         Mask => 0x80,
-        PrintConv => {
-            0x00 => 'Off',
-            0x80 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     1.2 => { # CS10-b
@@ -528,7 +481,7 @@
         Mask => 0x30,
         PrintConv => {
-            0x10 => 400,
-            0x20 => 800,
-            0x30 => 1600,
+            1 => 400,
+            2 => 800,
+            3 => 1600,
         },
     },
@@ -538,12 +491,12 @@
         PrintConvColumns => 2,
         PrintConv => {
-            0x00 => '1/125 s',
-            0x01 => '1/60 s',
-            0x02 => '1/30 s',
-            0x03 => '1/15 s',
-            0x04 => '1/8 s',
-            0x05 => '1/4 s',
-            0x06 => '1/2 s',
-            0x07 => '1 s',
+            0 => '1/125 s',
+            1 => '1/60 s',
+            2 => '1/30 s',
+            3 => '1/15 s',
+            4 => '1/8 s',
+            5 => '1/4 s',
+            6 => '1/2 s',
+            7 => '1 s',
         },
     },
@@ -552,9 +505,9 @@
         Mask => 0x07,
         PrintConv => {
-            0x00 => '4 s',
-            0x01 => '8 s',
-            0x02 => '20 s',
-            0x03 => '1 min',
-            0x04 => '10 min',
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '10 min',
         },
     },
@@ -563,9 +516,9 @@
         Mask => 0xe0,
         PrintConv => {
-            0x00 => '4 s',
-            0x20 => '8 s',
-            0x40 => '20 s',
-            0x60 => '1 min',
-            0x80 => '10 min',
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '10 min',
         },
     },
@@ -574,9 +527,9 @@
         Mask => 0x1c,
         PrintConv => {
-            0x00 => '4 s',
-            0x04 => '8 s',
-            0x08 => '20 s',
-            0x0c => '1 min',
-            0x10 => '30 min',
+            0 => '4 s',
+            1 => '8 s',
+            2 => '20 s',
+            3 => '1 min',
+            4 => '30 min',
         },
     },
@@ -585,8 +538,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => '2 s',
-            0x01 => '5 s',
-            0x02 => '10 s',
-            0x03 => '20 s',
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s',
+            3 => '20 s',
         },
     },
@@ -595,8 +548,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => '1 min',
-            0x40 => '5 min',
-            0x80 => '10 min',
-            0xc0 => '15 min',
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
         },
     },
@@ -605,9 +558,9 @@
         Mask => 0x0e,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x02 => 'AE Lock Only',
-            0x04 => 'AF Lock Only',
-            0x06 => 'AE Lock (hold)',
-            0x08 => 'AF-ON',
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only',
+            3 => 'AE Lock (hold)',
+            4 => 'AF-ON',
         },
     },
@@ -615,8 +568,5 @@
         Name => 'AELock',
         Mask => 0x01,
-        PrintConv => {
-            0x00 => 'Off',
-            0x01 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     5.1 => { # CS4
@@ -624,9 +574,9 @@
         Mask => 0x70,
         PrintConv => {
-            0x00 => 'Single Frame',
-            0x10 => 'Continuous',
-            0x20 => 'Self-timer',
-            0x30 => 'Delayed Remote',
-            0x40 => 'Quick-response Remote',
+            0 => 'Single Frame',
+            1 => 'Continuous',
+            2 => 'Self-timer',
+            3 => 'Delayed Remote',
+            4 => 'Quick-response Remote',
         },
     },
@@ -635,9 +585,9 @@
         Mask => 0x07,
         PrintConv => {
-            0x00 => 'Shooting Mode',
-            0x01 => 'Image Quality/Size',
-            0x02 => 'ISO',
-            0x03 => 'White Balance',
-            0x04 => 'Self-timer',
+            0 => 'Shooting Mode',
+            1 => 'Image Quality/Size',
+            2 => 'ISO',
+            3 => 'White Balance',
+            4 => 'Self-timer',
         },
     },
@@ -646,7 +596,7 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'Matrix',
-            0x01 => 'Center-weighted',
-            0x02 => 'Spot',
+            0 => 'Matrix',
+            1 => 'Center-weighted',
+            2 => 'Spot',
         },
     },
@@ -655,6 +605,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => 'TTL',
-            0x10 => 'Manual',
+            0 => 'TTL',
+            1 => 'Manual',
         },
     },
@@ -683,8 +633,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Manual',
-            0x40 => 'AF-S',
-            0x80 => 'AF-C',
-            0xc0 => 'AF-A',
+            0 => 'Manual',
+            1 => 'AF-S',
+            2 => 'AF-C',
+            3 => 'AF-A',
         },
     },
@@ -694,7 +644,7 @@
         Mask => 0x30,
         PrintConv => {
-            0x00 => 'Single Area',
-            0x10 => 'Dynamic Area',
-            0x20 => 'Closest Subject',
+            0 => 'Single Area',
+            1 => 'Dynamic Area',
+            2 => 'Closest Subject',
         },
     }
@@ -724,6 +674,6 @@
         Mask => 0x08,
         PrintConv => {
-            0x00 => 'LCD Backlight',
-            0x08 => 'LCD Backlight and Shooting Information',
+            0 => 'LCD Backlight',
+            1 => 'LCD Backlight and Shooting Information',
         },
     },
@@ -732,8 +682,8 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => 'Single Area',
-            0x20 => 'Dynamic Area',
-            0x40 => 'Auto-area',
-            0x60 => '3D-tracking (11 points)',
+            0 => 'Single Area',
+            1 => 'Dynamic Area',
+            2 => 'Auto-area',
+            3 => '3D-tracking (11 points)',
         },
     },
@@ -742,6 +692,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => 'Normal Zone',
-            0x10 => 'Wide Zone',
+            0 => 'Normal Zone',
+            1 => 'Wide Zone',
         },
     },
@@ -749,5 +699,5 @@
         Name => 'AFAssist',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'On', 0x01 => 'Off' },
+        PrintConv => \%onOff,
     },
     2.4 => { # CSa4
@@ -755,7 +705,7 @@
         Mask => 0x06,
         PrintConv => {
-            0x00 => 'Auto',
-            0x02 => 'On',
-            0x04 => 'Off',
+            0 => 'Auto',
+            1 => 'On',
+            2 => 'Off',
         },
     },
@@ -764,6 +714,6 @@
         Mask => 0x08,
         PrintConv => {
-            0x00 => 'No Wrap',
-            0x08 => 'Wrap',
+            0 => 'No Wrap',
+            1 => 'Wrap',
         },
     },
@@ -772,11 +722,11 @@
         Mask => 0x1c,
         PrintConv => {
-            0x00 => 'AE Lock Only',
-            0x04 => 'AF Lock Only',
-            0x08 => 'AE Lock (hold)',
-            0x0c => 'AF-On',
-            0x10 => 'FV Lock',
-            0x14 => 'Focus Point Selection',
-            0x1c => 'AE/AF Lock',
+            0 => 'AE Lock Only',
+            1 => 'AF Lock Only',
+            2 => 'AE Lock (hold)',
+            3 => 'AF-On',
+            4 => 'FV Lock',
+            5 => 'Focus Point Selection',
+            7 => 'AE/AF Lock',
         },
     },
@@ -785,8 +735,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => 'LR6 (AA alkaline)',
-            0x01 => 'HR6 (AA Ni-MH)',
-            0x02 => 'FR6 (AA lithium)',
-            0x03 => 'ZR6 (AA Ni-Mn)',
+            0 => 'LR6 (AA alkaline)',
+            1 => 'HR6 (AA Ni-MH)',
+            2 => 'FR6 (AA lithium)',
+            3 => 'ZR6 (AA Ni-Mn)',
         },
     },
@@ -794,13 +744,10 @@
         Name => 'Beep',
         Mask => 0x40,
-        PrintConv => {
-            0x40 => 'On',
-            0x00 => 'Off',
-        },
+        PrintConv => \%offOn,
     },
     4.2 => { # CSd2
         Name => 'GridDisplay',
         Mask => 0x02,
-        PrintConv => { 0x00 => 'Off', 0x02 => 'On' },
+        PrintConv => \%offOn,
     },
     4.3 => { # CSd3
@@ -808,7 +755,7 @@
         Mask => 0x0c,
         PrintConv => {
-            0x00 => 'Show ISO/Easy ISO',
-            0x04 => 'Show ISO Sensitivity',
-            0x0c => 'Show Frame Count',
+            0 => 'Show ISO/Easy ISO',
+            1 => 'Show ISO Sensitivity',
+            3 => 'Show Frame Count',
         },
     },
@@ -816,5 +763,5 @@
         Name => 'ViewfinderWarning',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'On', 0x01 => 'Off' },
+        PrintConv => \%onOff,
     },
     4.5 => { # CSf6
@@ -822,6 +769,6 @@
         Mask => 0x20,
         PrintConv => {
-            0x00 => 'Release Locked',
-            0x20 => 'Enable Release',
+            0 => 'Release Locked',
+            1 => 'Enable Release',
         },
     },
@@ -829,10 +776,10 @@
         Name => 'ScreenTips',
         Mask => 0x04,
-        PrintConv => { 0x00 => 'Off', 0x04 => 'On' },
+        PrintConv => \%offOn,
     },
     5.2 => { # CSd7
         Name => 'FileNumberSequence',
         Mask => 0x08,
-        PrintConv => { 0x00 => 'On', 0x08 => 'Off' },
+        PrintConv => \%onOff,
     },
     5.3 => { # CSd8
@@ -840,7 +787,7 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => 'Auto',
-            0x80 => 'Manual (dark on light)',
-            0xc0 => 'Manual (light on dark)',
+            0 => 'Auto',
+            2 => 'Manual (dark on light)',
+            3 => 'Manual (light on dark)',
         },
     },
@@ -848,10 +795,10 @@
         Name => 'LCDIllumination',
         Mask => 0x20,
-        PrintConv => { 0x00 => 'Off', 0x20 => 'On' },
+        PrintConv => \%offOn,
     },
     6.1 => { # CSb2
         Name => 'EasyExposureComp',
         Mask => 0x01,
-        PrintConv => { 0x00 => 'Off', 0x01 => 'On' },
+        PrintConv => \%offOn,
     },
     6.2 => { # CSf7
@@ -859,6 +806,6 @@
         Mask => 0x80,
         PrintConv => {
-            0x00 => '+ 0 -',
-            0x80 => '- 0 +',
+            0 => '+ 0 -',
+            1 => '- 0 +',
         },
     },
@@ -867,6 +814,6 @@
         Mask => 0x40,
         PrintConv => {
-            0x00 => '1/3 EV',
-            0x40 => '1/2 EV',
+            0 => '1/3 EV',
+            1 => '1/2 EV',
         },
     },
@@ -875,7 +822,7 @@
         Mask => 0x60,
         PrintConv => {
-            0x00 => '6 mm',
-            0x20 => '8 mm',
-            0x40 => '10 mm',
+            0 => '6 mm',
+            1 => '8 mm',
+            2 => '10 mm',
         },
     },
@@ -884,5 +831,5 @@
         Mask => 0x0f,
         ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
-        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5)) & 0x0f',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
         PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -891,6 +838,6 @@
         Name => 'FineTuneOptCenterWeighted',
         Mask => 0xf0,
-        ValueConv => '($val > 0x70 ? $val - 0x100 : $val) / 0x60',
-        ValueConvInv => '(int($val*6+($val>0?0.5:-0.5))<<4) & 0xf0',
+        ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
         PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -900,5 +847,5 @@
         Mask => 0x0f,
         ValueConv => '($val > 0x7 ? $val - 0x10 : $val) / 6',
-        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5)) & 0x0f',
+        ValueConvInv => 'int($val*6+($val>0?0.5:-0.5))',
         PrintConv => '$val ? sprintf("%+.2f", $val) : 0',
         PrintConvInv => 'Image::ExifTool::Exif::ConvertFraction($val)',
@@ -913,8 +860,5 @@
         Name => 'ExposureDelayMode',
         Mask => 0x40,
-        PrintConv => {
-            0x00 => 'Off',
-            0x40 => 'On',
-        },
+        PrintConv => \%offOn,
     },
     13.1 => { # CSe4
@@ -922,9 +866,9 @@
         Mask => 0xe0, #(NC)
         PrintConv => {
-            0x00 => 'AE & Flash', # default
-            0x20 => 'AE Only',
-            0x40 => 'Flash Only', #(NC)
-            0x60 => 'WB Bracketing', #(NC)
-            0x80 => 'Active D-Lighting', #(NC)
+            0 => 'AE & Flash', # default
+            1 => 'AE Only',
+            2 => 'Flash Only', #(NC)
+            3 => 'WB Bracketing', #(NC)
+            4 => 'Active D-Lighting', #(NC)
         },
     },
@@ -933,6 +877,6 @@
         Mask => 0x10,
         PrintConv => {
-            0x00 => '0,-,+',
-            0x10 => '-,0,+',
+            0 => '0,-,+',
+            1 => '-,0,+',
         },
     },
@@ -941,14 +885,14 @@
         Mask => 0x78,
         PrintConv => {
-            0x08 => 'Framing Grid',
-            0x10 => 'AF-area Mode',
-            0x18 => 'Center Focus Point',
-            0x20 => 'FV Lock', # default
-            0x28 => 'Flash Off',
-            0x30 => 'Matrix Metering',
-            0x38 => 'Center-weighted Metering',
-            0x40 => 'Spot Metering',
-            0x48 => 'My Menu Top',
-            0x50 => '+ NEF (RAW)',
+            1 => 'Framing Grid',
+            2 => 'AF-area Mode',
+            3 => 'Center Focus Point',
+            4 => 'FV Lock', # default
+            5 => 'Flash Off',
+            6 => 'Matrix Metering',
+            7 => 'Center-weighted Metering',
+            8 => 'Spot Metering',
+            9 => 'My Menu Top',
+            10 => '+ NEF (RAW)',
         },
     },
@@ -957,8 +901,8 @@
         Mask => 0x18,
         PrintConv => {
-            0x08 => 'Select Center Focus Point',
-            0x10 => 'Highlight Active Focus Point',
-            0x18 => 'Not Used', #(NC)
-            0x00 => 'Not Used', #(NC)
+            1 => 'Select Center Focus Point',
+            2 => 'Highlight Active Focus Point',
+            3 => 'Not Used', #(NC)
+            0 => 'Not Used', #(NC)
         },
     },
@@ -967,10 +911,10 @@
         Mask => 0x38,
         PrintConv => {
-            0x00 => 'AE/AF Lock',
-            0x08 => 'AE Lock Only',
-            0x10 => 'AF Lock Only', #(NC)
-            0x18 => 'AE Lock (hold)', #(NC)
-            0x20 => 'AF-ON', #(NC)
-            0x28 => 'FV Lock', #(NC)
+            0 => 'AE/AF Lock',
+            1 => 'AE Lock Only',
+            2 => 'AF Lock Only', #(NC)
+            3 => 'AE Lock (hold)', #(NC)
+            4 => 'AF-ON', #(NC)
+            5 => 'FV Lock', #(NC)
         },
     },
@@ -978,10 +922,10 @@
         Name => 'CommandDialsReverseRotation',
         Mask => 0x80,
-        PrintConv => { 0x00 => 'No', 0x80 => 'Yes' },
+        PrintConv => \%noYes,
     },
     18.2 => { # CSc1
         Name => 'ShutterReleaseButtonAE-L',
         Mask => 0x02,
-        PrintConv => { 0x00 => 'Off', 0x02 => 'On' },
+        PrintConv => \%offOn,
     },
     19.1 => { # CSc2
@@ -990,13 +934,13 @@
         PrintConvColumns => 2,
         PrintConv => {
-            0x00 => '4 s',
-            0x10 => '6 s', # default
-            0x20 => '8 s',
-            0x30 => '16 s',
-            0x40 => '30 s',
-            0x50 => '1 min',
-            0x60 => '5 min',
-            0x70 => '10 min',
-            0x80 => '30 min',
+            0 => '4 s',
+            1 => '6 s', # default
+            2 => '8 s',
+            3 => '16 s',
+            4 => '30 s',
+            5 => '1 min',
+            6 => '5 min',
+            7 => '10 min',
+            8 => '30 min',
         },
     },
@@ -1005,8 +949,8 @@
         Mask => 0x03,
         PrintConv => {
-            0x00 => '1 min',
-            0x01 => '5 min',
-            0x02 => '10 min',
-            0x03 => '15 min',
+            0 => '1 min',
+            1 => '5 min',
+            2 => '10 min',
+            3 => '15 min',
         },
     },
@@ -1015,8 +959,8 @@
         Mask => 0xc0,
         PrintConv => {
-            0x00 => '2 s',
-            0x40 => '5 s',
-            0x80 => '10 s', # default
-            0xc0 => '20 s',
+            0 => '2 s',
+            1 => '5 s',
+            2 => '10 s', # default
+            3 => '20 s',
         },
     },
@@ -1024,6 +968,4 @@
         Name => 'SelfTimerShotCount',
         Mask => 0x1e,
-        ValueConv => '$val >> 1',
-        ValueConvInv => '$val << 1',
     },
     21.1 => { # CSc4-a
